##############################################################################
# 
# Zope Public License (ZPL) Version 1.0
# -------------------------------------
# 
# Copyright (c) Digital Creations.  All rights reserved.
# 
# This license has been certified as Open Source(tm).
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are
# met:
# 
# 1. Redistributions in source code must retain the above copyright
#    notice, this list of conditions, and the following disclaimer.
# 
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions, and the following disclaimer in
#    the documentation and/or other materials provided with the
#    distribution.
# 
# 3. Digital Creations requests that attribution be given to Zope
#    in any manner possible. Zope includes a "Powered by Zope"
#    button that is installed by default. While it is not a license
#    violation to remove this button, it is requested that the
#    attribution remain. A significant investment has been put
#    into Zope, and this effort will continue if the Zope community
#    continues to grow. This is one way to assure that growth.
# 
# 4. All advertising materials and documentation mentioning
#    features derived from or use of this software must display
#    the following acknowledgement:
# 
#      "This product includes software developed by Digital Creations
#      for use in the Z Object Publishing Environment
#      (http://www.zope.org/)."
# 
#    In the event that the product being advertised includes an
#    intact Zope distribution (with copyright and license included)
#    then this clause is waived.
# 
# 5. Names associated with Zope or Digital Creations must not be used to
#    endorse or promote products derived from this software without
#    prior written permission from Digital Creations.
# 
# 6. Modified redistributions of any form whatsoever must retain
#    the following acknowledgment:
# 
#      "This product includes software developed by Digital Creations
#      for use in the Z Object Publishing Environment
#      (http://www.zope.org/)."
# 
#    Intact (re-)distributions of any official Zope release do not
#    require an external acknowledgement.
# 
# 7. Modifications are encouraged but must be packaged separately as
#    patches to official Zope releases.  Distributions that do not
#    clearly separate the patches from the original work must be clearly
#    labeled as unofficial distributions.  Modifications which do not
#    carry the name Zope may be packaged in any form, as long as they
#    conform to all of the clauses above.
# 
# 
# Disclaimer
# 
#   THIS SOFTWARE IS PROVIDED BY DIGITAL CREATIONS ``AS IS'' AND ANY
#   EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
#   IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
#   PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL DIGITAL CREATIONS OR ITS
#   CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
#   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
#   LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
#   USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
#   ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
#   OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
#   OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
#   SUCH DAMAGE.
# 
# 
# This software consists of contributions made by Digital Creations and
# many individuals on behalf of Digital Creations.  Specific
# attributions are listed in the accompanying credits file.
# 
##############################################################################


"""

Changes: 3/10/99 Ben Leslie

Hacked around a lot of stuff to get it to work on my system. Hopefully
this will be help to other ppl maybe.



"""


import string
# import imaplib
import notimap
imaplib = notimap
import time

class Connection:
    """ Used by #tree """

    def __init__(self, server, port, user):
	""" """
	self.connection = imaplib.IMAP4(server, port)
	self.connection.login(user.getUserName(), user._getPassword())


    def tpValues(self, list=None):
        """ Notes:

        The first level of breakdown from a connection is a Namespace.
        This method returns a list of Namespace objects.
        """
	nspaces = []  # namespaces

	n = string.strip(self.connection.namespace()[1][0])
	start = 0
	end = len(n)
	while 1:
	    # find the first '(('
	    x = string.find(n, '((', start, end)
	    if x == -1:
		break
	    start = x
            # find it's matching ))
	    y = string.find(n, '))', start, end)
	    start = y
	    nsetstring = (n[x+2:y])
            nset = string.split(nsetstring, ')(')
            for i in nset:
                l = len(i)
                p = string.find(i, '"', 1, l)
                # snarf out the namespace name
                nspace = i[1:p]
                p = string.find(i, '"', p+1, l)
                # snarf out the namespace seperator
                nspacesep = i[p+1:string.find(i, '"', p+1, l)]
		if (list == None):
			contents =  [1]
		else:
			tpy, contents =  self.connection.lsub("%s" % (nspace) , '"%%"')
		if contents != [None]:
	                if not nspace:
                	    nspace = ("Your Folders" + nspacesep)
		        nspaces.append(Namespace(nspace, nspacesep, self.connection))

	return nspaces


class Namespace:
    """ """

    def __init__(self, nspace, nspacesep, conn):
	self.id = self.shortname = nspace
        self.sep = nspacesep
	self.connection = conn
	self.icon = "misc_/IMAPAdapter/folder"

    def tpId(self):
        """ """
        return self.id

    def tpURL(self):
        """ """
        if self.shortname[:12] == "Your Folders":
            return ""            
        if self.shortname[-1] == self.sep:
            return self.shortname[:-1]
        return self.shortname

    def tpValues(self, list=None): 
        """ Notes: 
        The second level of breakdown in a
        Connection (below namespaces) are Folders.  If an item is flagged
        Noselect it is another Folder.  If it is marked Noinferiors it is
        an item of some sort: 
        """
        if self.id[:12] == "Your Folders":
		if (list  == None):
        	    typ, boxes = self.connection.list("", '"%%"')
		else:
	            typ, boxes = self.connection.lsub("", '"%%"')
        else:
		if (list == None):
	            typ, boxes = self.connection.list("", ('"%s%%"' % self.id))
		else:
	            typ, boxes = self.connection.lsub("", ('"%s%%"' % self.id))
        contentnames = []

        flgs = []


	for i in boxes:
		if (boxes.count(i) > 1) :
			for j in range(1, boxes.count(i)):
				boxes.remove(i)

	for i in boxes:
            if not i:
                break
            tmp = string.split(i, ('"%s"' % self.sep))
            if (len(tmp) == 1):        # this occurs if we don't split properly
                 tmp = string.split(i, 'NIL')
            # need to have dodgy hack because of ddginess
            last = string.strip(tmp[(len(tmp)-1)])
            if last[0] == '"':
                last = last[1:(len(last)-1)]

            tflgs = string.split(string.strip(tmp[0]), ' ')
            for j in tflgs:
                flgs.append(j[2:])

            if "NoSelect" in flgs and "NoInferiors" in flgs:
                contentnames.append(imapItem(
                    	last, self.id, flgs, self.sep, self.connection))
            else:
                contentnames.append(imapFolder(
                    last, self.id, flgs, self.sep, self.connection))
	return contentnames


class imapFolder:
    """ """

    def __init__(self, name, parent, flgs, sep, conn):
	self.id = name
        self.parent = parent
        self.flags = flgs
        self.sep = sep
        if self.parent[:12] == "Your Folders" or name == parent:
            self.shortname = self.id
        else:
            self.shortname = self.id[(len(self.parent)):]
        if (len(self.shortname) > 0):
		if self.shortname[0] == self.sep:
           		 self.shortname = self.shortname[1:]
	self.connection = conn
	self.icon = "misc_/IMAPAdapter/folder"
        try:
            if "NoSelect" not in flgs:
                typ, dat = conn.select(name)
                self.num = dat[0]
                try:
                    self.num = string.atoi(self.num)
                except:
                    self.num = None
        except:
            pass

    def tpId(self):
        """ """
        return self.id

    def tpURL(self):
        """ """
        return self.shortname

    def tpValues(self, list=None):
        """ Folders are recursive, they return a list of mixed folders 
        and items.
        """
	if (list == None):
		tpy, contents = self.connection.list("", ('"%s/%%"' % self.id))
	else:
		tpy, contents = self.connection.lsub("", ('"%s/%%"' % self.id))
        contentnames = []
        flgs = []

	# Remove any duplicates 

	for i in contents:
		if (contents.count(i) > 1) :
			for j in range(1, contents.count(i)):
				contents.remove(i)

        for i in contents:
            if not i:
                break
            tmp = string.split(i, ('"%s"' % self.sep))
            last = string.strip(tmp[(len(tmp)-1)])
            if last[0] == '"':
                last = last[1:(len(last)-1)]

            tflgs = string.split(string.strip(tmp[0]), ' ')
            for j in tflgs:
                flgs.append(j[2:])

            if ("NoInferiors" in flgs) and ("NoSelect" in flgs):
                contentnames.append(imapItem(
                    last, self.id, flgs, self.sep, self.connection))
            else:
	        contentnames.append(imapFolder(
        	            last, self.id, flgs, self.sep, self.connection))
        return contentnames



class imapItem:
    """ """

    def __init__(self, name, parent, flgs, sep, conn):
        self.id = name
        self.parent = parent
        self.flags = flgs
        self.sep = sep
        self.shortname = self.id[(len(self.parent)):]
        
        # Mmm for some strange reason it seems that shortname could be len 0 so test
        # for this

        if (len(self.shortname) > 0):
	    if self.shortname[0] == self.sep:
                self.shortname = self.shortname[1:]
        self.connection = conn
        self.icon = "misc_/IMAPAdapter/item"

    def tpId(self):
        """ """
        return self.id

    def tpURL(self):
        """ """
        return self.shortname



