import Acquisition
import ExtensionClass
import Persistence
import string
import time
from Message import Message

class Folder(ExtensionClass.Base, Acquisition.Implicit, Persistence.Persistent):
	"""


	"""

	def time(self, mess=None):
		print time.time(), mess
			
	def __init__(self, PARENTS, foldername):
		"""
		Initialisation
		
		"""
		self.PARENTS = PARENTS + [self]
		self.id = foldername

	def __len__(self):
		"""
			Return number of messges in folder
		"""
		if self.search != '':
			if not hasattr(self, 'uids'):
				err, result =  self.PARENTS[0].conn.connection.select(self.id)
				err, result =  self.PARENTS[0].conn.connection.search(None, '(text "%s")' %  self.search)
				self.uids = (string.split(result[0]))
			return len(self.uids)
		else:
			err, result = self.PARENTS[0].conn.connection.select(self.id)

		return string.atoi(result[0])
			


	def render(self, REQUEST):
		"""
			Return a DTML page to view this object
		"""
		if not REQUEST.has_key('search'):
			REQUEST['search'] = ''
		self.search = REQUEST['search']
		REQUEST['foldername'] = self.id
		REQUEST['sort'] = 'DATE'
		REQUEST['reverse'] = '1'
		REQUEST['num_folders'] = '20'
		REQUEST['folderObject'] = self
		if not REQUEST.has_key('query_start'):
			REQUEST['query_start'] = '1'
		self.time()
		return self.PARENTS[0].render_object('%s_folder' % self.PARENTS[-2].type, REQUEST)


	def keys(self):
		"""

			Returns the list of available data_types

		"""

		return filter(self.testFolder, self.getFolders(self.PARENTS[0].conn)) 

	def testFolder(self, folderName):
		"""
			This function can be voerloaded by subclasses to check
			that the folder name is actually a folder containing
			the relevant data for this data-type
		"""

		return 1

    	def getFolders(self, start):
		returnValue = []
		if start.tpValues(1) == []:
			if hasattr(start, 'tpId'):
				returnValue = returnValue + [start.tpId()]
		else:
			for x in start.tpValues(1):
				returnValue = returnValue + self.getFolders(x)
		return returnValue

	

	def __getitem__(self, index):
		"""

		"""
		return Message(self.PARENTS, uid=index)

	def isPreviousMessages(start, start_message):
		"""
			Returns true if there are items before the given message
		"""


		return 1


	def isNextMessages(start, end_message):
		"""
			Returns true if there are items before the given message
		"""


		return 1


	def delete(self, uids):
		"""
			Delete a list of UIDs and expunge them
			TODO: add error checking
			TODO: look add splitting delete and expunge
		"""
		conn = self.PARENTS[0].conn.connection
		conn.select(self.id)
		uids = self.convert_to_slice(uids)
		for x in uids:
			typ, c = conn.uid("STORE", x, "+FLAGS", "(\Deleted)")
		typ, c = conn.expunge()


	def move(self, uids, destination):
		"""
			Move a list of UIDs to another folder,
			just copy then delete! (easy :)
			Should check that they moved ok!
			TODO: Add error checking
		"""

		self.copy(uids, destination)
		self.delete(uids)

	def copy(self, uids, destination):
		"""
			Copy a list of UIDs to another folder
			TODO: Add error checking
		"""
		conn = self.PARENTS[0].conn.connection
		conn.select(self.id)
		uids = self.convert_to_slice(uids)
		for x in uids:
			typ, c = conn.uid("COPY", x, destination)


	def convert_to_slice(self, uids):
		"""
			This fill convert a set of uids 4, 5, 6, 9, 10, 13, 15
			Into a vlid list of IMAP message slices ie:
				4:6, 6, 9:10, 13, 15
			We do this so if we decide to delete 1, ... 10,000
			we  can streamline this into 1 imap call

			TODO: Implement this!
		"""

		return uids

	def __getslice__(self, low, high):
		"""

			Returns a list of summarised message data

		"""

		"""
			If we need to reverse the items this then we need to change the number around a bit :)
		"""

		conn = self.PARENTS[0].conn.connection
		self.slice_reverse = 1
		if self.slice_reverse:
			diff = high - low
			low = len(self) - high + 1
			high = low + diff

		# bound check
		if high > len(self): high = len(self) 
		if low < 1: low = 1

		self.PARENTS[0].conn.connection.select(self.id)
		if self.search == '':
			errmess, result =  conn.fetch("%s:%s" %(low, high), '(UID flags rfc822.size BODY[HEADER.FIELDS (SUBJECT FROM DATE X-PHONE)])')
		else:
			result = []
			if low == 1:
				uids = self.uids[:high]
			else:
				uids = self.uids[low-1:high]
			uids = self.convert_to_slice(uids)
			for x in uids:
				typ, c = conn.fetch("%s" %(x), '(UID flags rfc822.size BODY[HEADER.FIELDS (SUBJECT FROM DATE X-PHONE)])')
				result = result + c
		returnValue = []
		for x in result:
			if  len(x) == 2:
				returnValue = returnValue + [Message(self.PARENTS, init_string=x)]

		if self.slice_reverse:
			returnValue.reverse()

		return returnValue