import string
import base64
from imaplib import parse

class Imapmime:
	"""
		This class is resposnible for rendering a mime message from an imap server
	"""




	def __init__(self, conn, folder, uid, part_num, body):

		self.conn = conn
		self.folder = folder
		self.body = body
		self.uid = uid
		self.part_num = part_num
		self.parts = []
		print "Created ", part_num
		print body
		if body[-1] == '"MIXED"':
			# We have a multipart type message
			self.type = "MIME"
			self.subtype = "MIXED"
			for pos in range(0, len(body) - 1):
				self.parts.append(Imapmime(self.conn, self.folder, self.uid, pos+1, body[pos]))
		else:
			# We have a normal mime message bit
			self.type = self.stripQuote(body[0])
			self.subtype = self.stripQuote(body[1])
			self.encoding = self.stripQuote(body[5])


		"""
		ps = parse(description)
		print ps
		self.type = ps[0][0][0]
		self.subtype = ps[0][0][1]
		self.encoding = ps[0][0][5]
		print self.type, self.subtype, self.encoding
		"""
		"""
		if description[:2] == "((":
			self.type = "MIME"
			self.subtype = "don't know yet"
			# lets parse the different substring out
			description = description[1:-1]
			start_index = 1
			while start_index < len(description):

				close_ind = start_index - 1
				open_ind = start_index - 1
				while ((close_ind >= open_ind) and (open_ind!=-1)):
					close_ind = string.find(description, ")", close_ind+1)
					open_ind = string.find(description, "(", open_ind+1)

				self.parts = self.parts + [description[start_index:close_ind]]

				if open_ind == -1: 
					break
				else:
					start_index = close_ind + 2
			self.subtype = string.strip(description[close_ind+1:])[1:-1]
			self.encoding = 'base64'
		else:
			temp = string.split(description)
			self.type = temp[0][1:-1]
			self.subtype = temp[1][1:-1]
			self.encoding = temp[5][1:-1]			
		"""


	def __getitem__(self, index):
		"""
			Return the given part
		"""
		return self.parts[string.atoi(index)-1]

		"""
		mt = Imapmime(self.conn, self.folder, self.uid, '%s_%s' % (self.part_num, index), self.parts[string.atoi(index) - 1])
		return mt
		"""			

	def getRawData(self, RESPONSE=None):
		"""
		Decode and return the data without markup
		"""
		#part_num = string.join(string.split(self.part_num, "_")[1:], ".")
		#print part_num
		self.conn.select(self.folder)
		err, res2 = self.conn.uid("fetch" ,  self.uid, '(BODY[%s])' % self.part_num)
		if RESPONSE is not None:
			RESPONSE.setHeader('Content-type', "%s/%s" % (self.type, self.subtype))
		#print res2
		#print res2[0]
		stuff =  res2[0][1]
		print "getRawData"
		print self.body
		print self.encoding
		if self.encoding == "BASE64":		
			return base64.decodestring(stuff)
		else:
			return stuff


	def render(self):
		"""
		This returns HTML to view this message
		"""
		print "REndering for ", self.type, self.subtype
		if hasattr(self, "%s_%s" % (self.type, self.subtype)):
			return getattr(self, "%s_%s" % (self.type, self.subtype))()
		else:
			if hasattr(self, self.type):
				return getattr(self, self.type)()
			else:
				return self.DEFAULT()

	def TEXT_PLAIN(self):
		"""
			Render things of type text/plain into HTML
		"""

		
		self.conn.select(self.folder)
		part_num = 1
		if self.part_num:
			part_num = self.part_num
		print '(BODY[%s])' % part_num
		err, res2 = self.conn.uid("fetch" ,  self.uid, '(BODY[%s])' % part_num )
		print err, res2
		if len(res2) > 1:
			nothing, mail = res2[0]
			# TODO: Write code to truncate message to 80 lines			
		else:
			mail = string.split(res2[0])[-1][1:-2]
		retVal = "<PRE>%s</PRE>" % mail
		return retVal

	def TEXT_HTML(self):
		"""
			Renders things of type text/html into HTML
			Deceptively easy :)
		"""

		self.conn.select(self.folder)
		err, res2 = self.conn.uid("fetch" ,  self.uid, '(BODY[%s])' % self.part_num)
		print err, res2
		if len(res2) > 1:
			nothing, mail = res2[0]
		else:
			mail = string.split(res2[0])[-1][1:-2]
		retVal =  mail
		return retVal


	def MIME_MIXED(self):
		"""
			Render if it is type mime_mixed
		"""
		print "rendering mime_mixed"
		part_num = 0
		returnValue = ''
		print self.parts
		for each in self.parts:
			#part_num = part_num + 1
			#mt = Imapmime(self.conn, self.folder, self.uid, '%s_%s' % (self.part_num, part_num), each)
			returnValue = '%s<br>%s' % (returnValue, each.render())
		return returnValue


	def IMAGE_JPEG(self):
		"""
			REnder an IMAGE
		"""

		return '<IMG SRC="perform_action?get_data=&amp;foldername=%s&amp;uid=%s&amp;part=%s">' % (self.folder, self.uid, self.part_num)


	def IMAGE_GIF(self):
		"""
			REnder an IMAGE
		"""

		return '<IMG SRC="perform_action?get_data=&amp;foldername=%s&amp;uid=%s&amp;part=%s">' % (self.folder, self.uid, self.part_num)


	def DEFAULT(self):
		"""

			Default rendering if we don't know the type
		"""

		return '<A HREF="perform_action?get_data=&amp;foldername=%s&amp;uid=%s&amp;part=%s">Download Attachment</A>' % (self.folder, self.uid, self.part_num)


	def stripQuote(self, a_string):
		"""

		"""

		if a_string[0] == '"': return a_string[1:-1]
		else: return a_string	

	

	def getBody(self):
		"""

		"""

		retVal = ''

		if self.type == "TEXT":
			return self.getRawData()
		elif self.type == "MIME":
			for part in self.parts:
				pb = part.getBody()
				if pb != "":
					retVal = pb
					break
		
		return retVal