import Acquisition
import Persistence
import ExtensionClass
from Folders import Folders
from ContactFolders import ContactFolders

class MessageGroup(ExtensionClass.Base, Acquisition.Implicit, Persistence.Persistent):
	"""
		MessageGroup stores the different types of data that can be displayed

		Currently this is:

			e-mail
			contact

		Future Ideas include:

			todoitem
			meeting
			schedule_item
			other

		Message group will be used a dictionary type item

		ie:
			a_message_group_item.keys() = ('e-mail', 'contact')
			a_message_group_item['e-mail'] = email folders instance

	"""
			
	def __init__(self, parent):
		"""
		Initialisation
		
		"""
		print "MessageGroup initted"
		self.last_index = ''
		self.PARENTS = [parent, self]
	
	def keys(self):
		"""

			Returns the list of available data_types

		"""
		return self.PARENTS[0].data_types

	def __getitem__(self, index):
		"""

			Returns the a folders instance for the given index

		"""
		print "GetItem Index:" , index
	
		if self.last_index != index:
			if index == 'contact':
				self.last_item = ContactFolders(self.PARENTS)
			else:
				self.last_item = Folders(self.PARENTS)
			self.last_index = index
		return self.last_item


	def render(self, REQUEST):
		"""
			Manage your folders!
		"""
		REQUEST['messageGroupObject'] = self
		return self.PARENTS[0].render_object('manage_all_folders', REQUEST)


	def unsubscribe(self, folder_name):
		"""
			Unsubscribe from a given folder
			TODO: Error check this better
		"""

		self.PARENTS[0].conn.connection.unsubscribe(folder_name)

	def subscribe(self, folder_name):
		"""
			Unsubscribe from a given folder
			TODO: Error check this better
		"""
		self.PARENTS[0].conn.connection.subscribe('"' + folder_name + '"')

	def create(self, folder_name):
		"""
			Create a given folder
			TODO: Error check this better
		"""
		self.PARENTS[0].conn.connection.create('"' + folder_name + '"')

	def delete(self, folder_name):
		"""
			Create a given folder
			TODO: Error check this better
		"""
		self.PARENTS[0].conn.connection.delete('"' + folder_name + '"')

	def rename(self, folder_name, new_name):
		"""
			Create a given folder
			TODO: Error check this better
		"""
		self.PARENTS[0].conn.connection.rename(('"' + folder_name + '"'), ('"' + new_name + '"'))

