##############################################################################
# 
# Zope Public License (ZPL) Version 1.0
# -------------------------------------
# 
# Copyright (c) Digital Creations.  All rights reserved.
# 
# This license has been certified as Open Source(tm).
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are
# met:
# 
# 1. Redistributions in source code must retain the above copyright
#    notice, this list of conditions, and the following disclaimer.
# 
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions, and the following disclaimer in
#    the documentation and/or other materials provided with the
#    distribution.
# 
# 3. Digital Creations requests that attribution be given to Zope
#    in any manner possible. Zope includes a "Powered by Zope"
#    button that is installed by default. While it is not a license
#    violation to remove this button, it is requested that the
#    attribution remain. A significant investment has been put
#    into Zope, and this effort will continue if the Zope community
#    continues to grow. This is one way to assure that growth.
# 
# 4. All advertising materials and documentation mentioning
#    features derived from or use of this software must display
#    the following acknowledgement:
# 
#      "This product includes software developed by Digital Creations
#      for use in the Z Object Publishing Environment
#      (http://www.zope.org/)."
# 
#    In the event that the product being advertised includes an
#    intact Zope distribution (with copyright and license included)
#    then this clause is waived.
# 
# 5. Names associated with Zope or Digital Creations must not be used to
#    endorse or promote products derived from this software without
#    prior written permission from Digital Creations.
# 
# 6. Modified redistributions of any form whatsoever must retain
#    the following acknowledgment:
# 
#      "This product includes software developed by Digital Creations
#      for use in the Z Object Publishing Environment
#      (http://www.zope.org/)."
# 
#    Intact (re-)distributions of any official Zope release do not
#    require an external acknowledgement.
# 
# 7. Modifications are encouraged but must be packaged separately as
#    patches to official Zope releases.  Distributions that do not
#    clearly separate the patches from the original work must be clearly
#    labeled as unofficial distributions.  Modifications which do not
#    carry the name Zope may be packaged in any form, as long as they
#    conform to all of the clauses above.
# 
# 
# Disclaimer
# 
#   THIS SOFTWARE IS PROVIDED BY DIGITAL CREATIONS ``AS IS'' AND ANY
#   EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
#   IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
#   PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL DIGITAL CREATIONS OR ITS
#   CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
#   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
#   LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
#   USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
#   ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
#   OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
#   OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
#   SUCH DAMAGE.
# 
# 
# This software consists of contributions made by Digital Creations and
# many individuals on behalf of Digital Creations.  Specific
# attributions are listed in the accompanying credits file.
# 
##############################################################################

"""



TODO: Shouldn't loop stupidly creating many connections, should pack into 
on connection .. ie UID FETCH 100:302 (FLAGS RFC822.SIZE) instead of

UID FETCH 100 FLAGS
UID FETCH 100 RFC822.SIZE
UID FETCH 101 FLAGS
UID FETCH 101 RFC822.SIZE
etc.. way too much overhead.. not too bad if loop is only 20 though so ignore
for the moment.. work on other things..


Changes:

3/10/99: (Ben Leslie)

Added threading functionality. Doesn't do much good. Simply returns
items in a list be in threaded order.

Added ability to sort entries on the follwing

DATE
FROM
SUBJECT


TODO: Work out way to cache expensive lookups from IMAP server

"""

__version__='$Revision: 1.4 $'[11:-2]

import string
import rfc822
import notmime
import time
from MessageGroup import MessageGroup
from Connection import Connection
from AccessControl.User import BasicUser
from cStringIO import StringIO

class imapUser(BasicUser):
	""" 
	The IMAP functionality is user-centric.  The whole Zope IMAP API
	is exposed through the imapUser object.  In Zope speak, an
	imapUser object works the same as any other type of user object.
	Typically it is used in DTML with the AUTHENTICATED_USER
	variable.  The simplest example of using an imapUser object is the 
	following DTML:
    
	<!--#var standard_html_header-->
	<!--#with AUTHENTICATED_USER-->
	<!--#tree expr="imapFolderTree(REQUEST)" sort=id nowrap=1-->
	<img src=<!--#var icon-->><!--#var id-->
	<!--#/tree-->
	<!--#/with-->
	<!--#var standard_html_footer-->

	This snipped will show you the tree breakdown of the user's IMAP
	folders.
	"""
     
	data_types = ('email', 'contact')

    
	def __init__(self, name, password, roles, domains):
		print "IMAPUser %s initted" % name
	        self.name   =name
        	self.__     =password
	        self.roles  =filter(None, map(string.strip, 
                                      string.split(roles, ',')))
	        self.domains=filter(None, map(string.strip, 
                                      string.split(domains, ',')))
	        self.conn = None
		self.messageGroup = MessageGroup(self)
    
	def render_object(self, object, REQUEST):
		return getattr(REQUEST['PARENTS'][0], object)(REQUEST['PARENTS'][0], REQUEST)
    
	def getUserName(self):
        	return self.name
    
	def _getPassword(self):
        	return self.__

	def getRoles(self):
		return self.roles

	def getDomains(self):
		return self.domains
	    
	def connect(self, imap_server, imap_port):
        	""" used by IMAPAdapter.IMAPAdapter.IMAPAdapter.validate """
	        try:
        	    	conn = Connection(imap_server, imap_port, self)
	        except:
			return None
	        self.conn = conn
        	return conn

	def getMessageGroups(self):
		"""
			Message Groups will return a message_group object
		"""
		x = MessageGroup(self)
		return x



