__doc__ = """ This adds an extension to imaplib to support the
NAMESPACE extension to IMAP.
"""

"""

Changes: 3/10/99 Ben Leslie
Added 'THREAD' tp the Commands

"""

from imaplib import *

Commands['NAMESPACE'] = ('AUTH', 'SELECTED')
Commands['THREAD'] = ('SELECTED', )
Commands['SORT'] = ('SELECTED', )


class IMAP4(IMAP4):
    """ The NotIMAP extension to the IMAP4 class) """
    def namespace(self):
	""" Returns namespaces.  The server MUST have NAMESPACE listed 
	in it's capabilities.
	"""
	name = 'NAMESPACE'
	typ, dat = self._simple_command(name)
	return self._untagged_response(typ, dat, name)
    
